submodule-config: keep shallow recommendation around
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 11 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
091a6eb0
JK
49# Resolve a path to be relative to another path. This is intended for
50# converting submodule paths when git-submodule is run in a subdirectory
51# and only handles paths where the directory separator is '/'.
52#
53# The output is the first argument as a path relative to the second argument,
54# which defaults to $wt_prefix if it is omitted.
55relative_path ()
56{
57 local target curdir result
58 target=$1
59 curdir=${2-$wt_prefix}
60 curdir=${curdir%/}
61 result=
62
63 while test -n "$curdir"
64 do
65 case "$target" in
66 "$curdir/"*)
67 target=${target#"$curdir"/}
68 break
69 ;;
70 esac
71
72 result="${result}../"
73 if test "$curdir" = "${curdir%/*}"
74 then
75 curdir=
76 else
77 curdir="${curdir%/*}"
78 fi
79 done
80
81 echo "$result$target"
82}
83
be9d0a3a
HV
84die_if_unmatched ()
85{
86 if test "$1" = "#unmatched"
87 then
88 exit 1
89 fi
90}
91
88ce00c3
TK
92#
93# Print a submodule configuration setting
94#
95# $1 = submodule name
96# $2 = option name
97# $3 = default value
98#
99# Checks in the usual git-config places first (for overrides),
100# otherwise it falls back on .gitmodules. This allows you to
101# distribute project-wide defaults in .gitmodules, while still
102# customizing individual repositories if necessary. If the option is
103# not in .gitmodules either, print a default value.
104#
105get_submodule_config () {
106 name="$1"
107 option="$2"
108 default="$3"
109 value=$(git config submodule."$name"."$option")
110 if test -z "$value"
111 then
112 value=$(git config -f .gitmodules submodule."$name"."$option")
113 fi
114 printf '%s' "${value:-$default}"
115}
116
862ae6cd
RS
117isnumber()
118{
119 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
120}
121
14111fc4
JK
122# Sanitize the local git environment for use within a submodule. We
123# can't simply use clear_local_git_env since we want to preserve some
124# of the settings from GIT_CONFIG_PARAMETERS.
125sanitize_submodule_env()
126{
89044baa 127 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 128 clear_local_git_env
89044baa 129 GIT_CONFIG_PARAMETERS=$save_config
860cba61 130 export GIT_CONFIG_PARAMETERS
14111fc4
JK
131}
132
ecda0723
SV
133#
134# Add a new submodule to the working tree, .gitmodules and the index
135#
ec05df35 136# $@ = repo path
ecda0723
SV
137#
138# optional branch is stored in global branch variable
139#
23a485e3 140cmd_add()
ecda0723 141{
5c08dbbd 142 # parse $args after "submodule ... add".
091a6eb0 143 reference_path=
5c08dbbd
JH
144 while test $# -ne 0
145 do
146 case "$1" in
147 -b | --branch)
148 case "$2" in '') usage ;; esac
149 branch=$2
150 shift
151 ;;
d27b876b
JL
152 -f | --force)
153 force=$1
154 ;;
5c08dbbd 155 -q|--quiet)
2e6a30ef 156 GIT_QUIET=1
5c08dbbd 157 ;;
d92a3959
MT
158 --reference)
159 case "$2" in '') usage ;; esac
091a6eb0 160 reference_path=$2
d92a3959
MT
161 shift
162 ;;
163 --reference=*)
091a6eb0 164 reference_path="${1#--reference=}"
d92a3959 165 ;;
73b0898d
JL
166 --name)
167 case "$2" in '') usage ;; esac
168 custom_name=$2
169 shift
170 ;;
275cd184
FG
171 --depth)
172 case "$2" in '') usage ;; esac
173 depth="--depth=$2"
174 shift
175 ;;
176 --depth=*)
177 depth=$1
178 ;;
5c08dbbd
JH
179 --)
180 shift
181 break
182 ;;
183 -*)
184 usage
185 ;;
186 *)
187 break
188 ;;
189 esac
190 shift
191 done
192
091a6eb0
JK
193 if test -n "$reference_path"
194 then
195 is_absolute_path "$reference_path" ||
196 reference_path="$wt_prefix$reference_path"
197
198 reference="--reference=$reference_path"
199 fi
200
ecda0723 201 repo=$1
64394e3a 202 sm_path=$2
ecda0723 203
64394e3a 204 if test -z "$sm_path"; then
6a066230 205 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
206 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
207 fi
208
496eeeb1 209 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
210 usage
211 fi
212
091a6eb0
JK
213 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
214
ec05df35
ML
215 # assure repo is absolute or relative to parent
216 case "$repo" in
217 ./*|../*)
091a6eb0
JK
218 test -z "$wt_prefix" ||
219 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
220
ec05df35 221 # dereference source url relative to parent's url
63e95beb 222 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
223 ;;
224 *:*|/*)
225 # absolute url
226 realrepo=$repo
227 ;;
228 *)
497ee872 229 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
230 ;;
231 esac
232
db75ada5
MG
233 # normalize path:
234 # multiple //; leading ./; /./; /../; trailing /
64394e3a 235 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
236 sed -e '
237 s|//*|/|g
238 s|^\(\./\)*||
8196e728 239 s|/\(\./\)*|/|g
db75ada5
MG
240 :start
241 s|\([^/]*\)/\.\./||
242 tstart
243 s|/*$||
244 ')
64394e3a
RJ
245 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
246 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 247
64394e3a 248 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 249 then
6ff875c5 250 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 251\$sm_path
6ff875c5 252Use -f if you really want to add it." >&2
d27b876b
JL
253 exit 1
254 fi
255
73b0898d
JL
256 if test -n "$custom_name"
257 then
258 sm_name="$custom_name"
259 else
260 sm_name="$sm_path"
261 fi
262
d4264ca3 263 # perhaps the path exists and is already a git repo, else clone it
64394e3a 264 if test -e "$sm_path"
d4264ca3 265 then
496eeeb1 266 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 267 then
64394e3a 268 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 269 else
64394e3a 270 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 271 fi
c2f93917 272
d4264ca3 273 else
4b7c286e
JL
274 if test -d ".git/modules/$sm_name"
275 then
276 if test -z "$force"
277 then
278 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
279 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
280 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
281 echo >&2 " $realrepo"
282 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
283 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
284 else
285 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
286 fi
287 fi
d10e3b42 288 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 289 (
14111fc4 290 sanitize_submodule_env
d851ffb9
JH
291 cd "$sm_path" &&
292 # ash fails to wordsplit ${branch:+-b "$branch"...}
293 case "$branch" in
294 '') git checkout -f -q ;;
295 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
296 esac
297 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 298 fi
73b0898d 299 git config submodule."$sm_name".url "$realrepo"
d4264ca3 300
64394e3a
RJ
301 git add $force "$sm_path" ||
302 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 303
73b0898d
JL
304 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
305 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
306 if test -n "$branch"
307 then
308 git config -f .gitmodules submodule."$sm_name".branch "$branch"
309 fi &&
31991b02 310 git add --force .gitmodules ||
64394e3a 311 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
312}
313
19a31f9c
ML
314#
315# Execute an arbitrary command sequence in each checked out
316# submodule
317#
318# $@ = command to execute
319#
320cmd_foreach()
321{
1d5bec8b
JH
322 # parse $args after "submodule ... foreach".
323 while test $# -ne 0
324 do
325 case "$1" in
326 -q|--quiet)
327 GIT_QUIET=1
328 ;;
15fc56a8
JH
329 --recursive)
330 recursive=1
331 ;;
1d5bec8b
JH
332 -*)
333 usage
334 ;;
335 *)
336 break
337 ;;
338 esac
339 shift
340 done
341
f030c96d
ÆAB
342 toplevel=$(pwd)
343
4dca1aa6
BC
344 # dup stdin so that it can be restored when running the external
345 # command in the subshell (and a recursive call to this function)
346 exec 3<&0
347
74703a1e 348 git submodule--helper list --prefix "$wt_prefix"|
64394e3a 349 while read mode sha1 stage sm_path
19a31f9c 350 do
be9d0a3a 351 die_if_unmatched "$mode"
64394e3a 352 if test -e "$sm_path"/.git
19a31f9c 353 then
ea2fa104
SB
354 displaypath=$(relative_path "$prefix$sm_path")
355 say "$(eval_gettext "Entering '\$displaypath'")"
0ea306ef 356 name=$(git submodule--helper name "$sm_path")
15fc56a8 357 (
64394e3a 358 prefix="$prefix$sm_path/"
14111fc4 359 sanitize_submodule_env
64394e3a 360 cd "$sm_path" &&
091a6eb0
JK
361 sm_path=$(relative_path "$sm_path") &&
362 # we make $path available to scripts ...
363 path=$sm_path &&
1c4fb136
AK
364 if test $# -eq 1
365 then
366 eval "$1"
367 else
368 "$@"
369 fi &&
15fc56a8
JH
370 if test -n "$recursive"
371 then
372 cmd_foreach "--recursive" "$@"
373 fi
4dca1aa6 374 ) <&3 3<&- ||
ea2fa104 375 die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
376 fi
377 done
378}
379
70c7ac22 380#
211b7f19 381# Register submodules in .git/config
70c7ac22
LH
382#
383# $@ = requested paths (default to all)
384#
23a485e3 385cmd_init()
70c7ac22 386{
5c08dbbd
JH
387 # parse $args after "submodule ... init".
388 while test $# -ne 0
389 do
390 case "$1" in
391 -q|--quiet)
2e6a30ef 392 GIT_QUIET=1
5c08dbbd
JH
393 ;;
394 --)
395 shift
396 break
397 ;;
398 -*)
399 usage
400 ;;
401 *)
402 break
403 ;;
404 esac
405 shift
406 done
407
3604242f 408 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper init ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} "$@"
70c7ac22
LH
409}
410
cf419828
JL
411#
412# Unregister submodules from .git/config and remove their work tree
413#
414# $@ = requested paths (use '.' to deinit all submodules)
415#
416cmd_deinit()
417{
418 # parse $args after "submodule ... deinit".
f6a52799 419 deinit_all=
cf419828
JL
420 while test $# -ne 0
421 do
422 case "$1" in
423 -f|--force)
424 force=$1
425 ;;
426 -q|--quiet)
427 GIT_QUIET=1
428 ;;
f6a52799
SB
429 --all)
430 deinit_all=t
431 ;;
cf419828
JL
432 --)
433 shift
434 break
435 ;;
436 -*)
437 usage
438 ;;
439 *)
440 break
441 ;;
442 esac
443 shift
444 done
445
f6a52799
SB
446 if test -n "$deinit_all" && test "$#" -ne 0
447 then
448 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
449 usage
450 fi
451 if test $# = 0 && test -z "$deinit_all"
cf419828 452 then
f6a52799 453 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
cf419828
JL
454 fi
455
74703a1e 456 git submodule--helper list --prefix "$wt_prefix" "$@" |
cf419828
JL
457 while read mode sha1 stage sm_path
458 do
459 die_if_unmatched "$mode"
0ea306ef 460 name=$(git submodule--helper name "$sm_path") || exit
cf419828 461
091a6eb0
JK
462 displaypath=$(relative_path "$sm_path")
463
cf419828
JL
464 # Remove the submodule work tree (unless the user already did it)
465 if test -d "$sm_path"
466 then
467 # Protect submodules containing a .git directory
468 if test -d "$sm_path/.git"
469 then
091a6eb0 470 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
471 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
472 fi
473
474 if test -z "$force"
475 then
7b294bf4 476 git rm -qn "$sm_path" ||
091a6eb0 477 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 478 fi
7b294bf4 479 rm -rf "$sm_path" &&
091a6eb0
JK
480 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
481 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
482 fi
483
091a6eb0 484 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
485
486 # Remove the .git/config entries (unless the user already did it)
487 if test -n "$(git config --get-regexp submodule."$name\.")"
488 then
489 # Remove the whole section so we have a clean state when
490 # the user later decides to init this submodule again
491 url=$(git config submodule."$name".url)
492 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 493 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
494 fi
495 done
496}
497
fb43e31f 498is_tip_reachable () (
01e1d544 499 sanitize_submodule_env &&
fb43e31f
SB
500 cd "$1" &&
501 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
502 test -z "$rev"
503)
504
505fetch_in_submodule () (
01e1d544 506 sanitize_submodule_env &&
fb43e31f
SB
507 cd "$1" &&
508 case "$2" in
509 '')
510 git fetch ;;
511 *)
512 git fetch $(get_default_remote) "$2" ;;
513 esac
514)
515
70c7ac22 516#
211b7f19 517# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
518#
519# $@ = requested paths (default to all)
520#
23a485e3 521cmd_update()
70c7ac22 522{
5c08dbbd
JH
523 # parse $args after "submodule ... update".
524 while test $# -ne 0
525 do
526 case "$1" in
527 -q|--quiet)
2e6a30ef 528 GIT_QUIET=1
5c08dbbd 529 ;;
be4d2c83 530 -i|--init)
d92a3959 531 init=1
be4d2c83 532 ;;
06b1abb5
TK
533 --remote)
534 remote=1
535 ;;
31ca3ac3 536 -N|--no-fetch)
31ca3ac3
FF
537 nofetch=1
538 ;;
9db31bdf
NMC
539 -f|--force)
540 force=$1
541 ;;
ca2cedba 542 -r|--rebase)
32948425 543 update="rebase"
ca2cedba 544 ;;
d92a3959
MT
545 --reference)
546 case "$2" in '') usage ;; esac
547 reference="--reference=$2"
98dbe63d 548 shift
d92a3959
MT
549 ;;
550 --reference=*)
551 reference="$1"
d92a3959 552 ;;
42b49178 553 -m|--merge)
42b49178
JH
554 update="merge"
555 ;;
b13fd5c1 556 --recursive)
b13fd5c1
JH
557 recursive=1
558 ;;
efc5fb6a
JH
559 --checkout)
560 update="checkout"
561 ;;
275cd184
FG
562 --depth)
563 case "$2" in '') usage ;; esac
564 depth="--depth=$2"
565 shift
566 ;;
567 --depth=*)
568 depth=$1
569 ;;
2335b870
SB
570 -j|--jobs)
571 case "$2" in '') usage ;; esac
572 jobs="--jobs=$2"
573 shift
574 ;;
575 --jobs=*)
576 jobs=$1
577 ;;
5c08dbbd
JH
578 --)
579 shift
580 break
581 ;;
582 -*)
583 usage
584 ;;
585 *)
586 break
587 ;;
588 esac
98dbe63d 589 shift
5c08dbbd
JH
590 done
591
d92a3959
MT
592 if test -n "$init"
593 then
594 cmd_init "--" "$@" || return
595 fi
596
48308681
SB
597 {
598 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
599 ${wt_prefix:+--prefix "$wt_prefix"} \
600 ${prefix:+--recursive-prefix "$prefix"} \
601 ${update:+--update "$update"} \
602 ${reference:+--reference "$reference"} \
603 ${depth:+--depth "$depth"} \
2335b870 604 ${jobs:+$jobs} \
48308681
SB
605 "$@" || echo "#unmatched"
606 } | {
15ffb7cd 607 err=
48308681 608 while read mode sha1 stage just_cloned sm_path
70c7ac22 609 do
be9d0a3a 610 die_if_unmatched "$mode"
48308681 611
0ea306ef 612 name=$(git submodule--helper name "$sm_path") || exit
5be60078 613 url=$(git config submodule."$name".url)
d851ffb9 614 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
615 if ! test -z "$update"
616 then
617 update_module=$update
618 else
619 update_module=$(git config submodule."$name".update)
a2aed08b
TK
620 if test -z "$update_module"
621 then
622 update_module="checkout"
623 fi
efc5fb6a
JH
624 fi
625
091a6eb0
JK
626 displaypath=$(relative_path "$prefix$sm_path")
627
48308681 628 if test $just_cloned -eq 1
d851ffb9 629 then
bf2d8246 630 subsha1=
48308681 631 update_module=checkout
bf2d8246 632 else
14111fc4 633 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 634 git rev-parse --verify HEAD) ||
091a6eb0 635 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 636 fi
211b7f19 637
06b1abb5
TK
638 if test -n "$remote"
639 then
640 if test -z "$nofetch"
641 then
642 # Fetch remote before determining tracking $sha1
14111fc4 643 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
06b1abb5
TK
644 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
645 fi
14111fc4
JK
646 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
647 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5
TK
648 git rev-parse --verify "${remote_name}/${branch}") ||
649 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
650 fi
651
496eeeb1 652 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 653 then
9db31bdf
NMC
654 subforce=$force
655 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 656 if test -z "$subsha1" && test -z "$force"
b9b378a0 657 then
9db31bdf 658 subforce="-f"
b9b378a0 659 fi
31ca3ac3
FF
660
661 if test -z "$nofetch"
662 then
e5f522d6
JL
663 # Run fetch only if $sha1 isn't present or it
664 # is not reachable from a ref.
fb43e31f
SB
665 is_tip_reachable "$sm_path" "$sha1" ||
666 fetch_in_submodule "$sm_path" ||
091a6eb0 667 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
668
669 # Now we tried the usual fetch, but $sha1 may
670 # not be reachable from any of the refs
671 is_tip_reachable "$sm_path" "$sha1" ||
672 fetch_in_submodule "$sm_path" "$sha1" ||
673 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain $sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
674 fi
675
877449c1 676 must_die_on_failure=
32948425 677 case "$update_module" in
a2aed08b
TK
678 checkout)
679 command="git checkout $subforce -q"
680 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
681 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
682 ;;
32948425
JH
683 rebase)
684 command="git rebase"
091a6eb0
JK
685 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
686 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 687 must_die_on_failure=yes
32948425 688 ;;
42b49178
JH
689 merge)
690 command="git merge"
091a6eb0
JK
691 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
692 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 693 must_die_on_failure=yes
42b49178 694 ;;
6cb5728c
CP
695 !*)
696 command="${update_module#!}"
b08238ac
SB
697 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
698 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
699 must_die_on_failure=yes
700 ;;
32948425 701 *)
a2aed08b 702 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 703 esac
70c7ac22 704
14111fc4 705 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 706 then
ff968f03 707 say "$say_msg"
877449c1
JH
708 elif test -n "$must_die_on_failure"
709 then
ff968f03 710 die_with_status 2 "$die_msg"
15ffb7cd 711 else
ff968f03 712 err="${err};$die_msg"
877449c1 713 continue
15ffb7cd 714 fi
70c7ac22 715 fi
b13fd5c1
JH
716
717 if test -n "$recursive"
718 then
75bf5e60 719 (
3604242f
SB
720 prefix=$(relative_path "$prefix$sm_path/")
721 wt_prefix=
14111fc4 722 sanitize_submodule_env
75bf5e60 723 cd "$sm_path" &&
36141282 724 eval cmd_update
75bf5e60 725 )
15ffb7cd
FG
726 res=$?
727 if test $res -gt 0
728 then
091a6eb0 729 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
730 if test $res -eq 1
731 then
ff968f03 732 err="${err};$die_msg"
15ffb7cd
FG
733 continue
734 else
ff968f03 735 die_with_status $res "$die_msg"
15ffb7cd
FG
736 fi
737 fi
b13fd5c1 738 fi
70c7ac22 739 done
15ffb7cd
FG
740
741 if test -n "$err"
742 then
743 OIFS=$IFS
744 IFS=';'
745 for e in $err
746 do
747 if test -n "$e"
748 then
749 echo >&2 "$e"
750 fi
751 done
752 IFS=$OIFS
753 exit 1
754 fi
755 }
70c7ac22
LH
756}
757
bffe71f4
EM
758set_name_rev () {
759 revname=$( (
14111fc4 760 sanitize_submodule_env
bffe71f4 761 cd "$1" && {
5be60078
JH
762 git describe "$2" 2>/dev/null ||
763 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
764 git describe --contains "$2" 2>/dev/null ||
765 git describe --all --always "$2"
bffe71f4
EM
766 }
767 ) )
768 test -z "$revname" || revname=" ($revname)"
769}
28f9af5d
PY
770#
771# Show commit summary for submodules in index or working tree
772#
773# If '--cached' is given, show summary between index and given commit,
774# or between working tree and given commit
775#
776# $@ = [commit (default 'HEAD'),] requested paths (default all)
777#
778cmd_summary() {
f2dc06a3 779 summary_limit=-1
d0f64dd4 780 for_status=
1c244f6e 781 diff_cmd=diff-index
f2dc06a3 782
28f9af5d
PY
783 # parse $args after "submodule ... summary".
784 while test $# -ne 0
785 do
786 case "$1" in
787 --cached)
788 cached="$1"
789 ;;
1c244f6e
JL
790 --files)
791 files="$1"
792 ;;
d0f64dd4
PY
793 --for-status)
794 for_status="$1"
795 ;;
f2dc06a3 796 -n|--summary-limit)
862ae6cd
RS
797 summary_limit="$2"
798 isnumber "$summary_limit" || usage
f2dc06a3
PY
799 shift
800 ;;
862ae6cd
RS
801 --summary-limit=*)
802 summary_limit="${1#--summary-limit=}"
803 isnumber "$summary_limit" || usage
804 ;;
28f9af5d
PY
805 --)
806 shift
807 break
808 ;;
809 -*)
810 usage
811 ;;
812 *)
813 break
814 ;;
815 esac
816 shift
817 done
bffe71f4 818
f2dc06a3
PY
819 test $summary_limit = 0 && return
820
3deea89c 821 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
822 then
823 head=$rev
caa9c3ca 824 test $# = 0 || shift
496eeeb1 825 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 826 then
14e940d7
JH
827 # before the first commit: compare with an empty tree
828 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 829 test -z "$1" || shift
28f9af5d 830 else
3deea89c 831 head="HEAD"
28f9af5d
PY
832 fi
833
1c244f6e
JL
834 if [ -n "$files" ]
835 then
836 test -n "$cached" &&
465d6a00 837 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
838 diff_cmd=diff-files
839 head=
840 fi
841
28f9af5d 842 cd_to_toplevel
091a6eb0 843 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 844 # Get modified modules cared by user
18076502 845 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 846 sane_egrep '^:([0-7]* )?160000' |
2be94509 847 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
848 do
849 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
850 if test "$status" = D || test "$status" = T
851 then
6a066230 852 printf '%s\n' "$sm_path"
496eeeb1
EP
853 continue
854 fi
927b26f8 855 # Respect the ignore setting for --for-status.
856 if test -n "$for_status"
857 then
0ea306ef 858 name=$(git submodule--helper name "$sm_path")
927b26f8 859 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 860 test $status != A && test $ignore_config = all && continue
927b26f8 861 fi
28f9af5d 862 # Also show added or modified modules which are checked out
2be94509 863 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 864 printf '%s\n' "$sm_path"
28f9af5d
PY
865 done
866 )
1cb639e6 867
d0f64dd4
PY
868 test -z "$modules" && return
869
18076502 870 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 871 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
872 cut -c2- |
873 while read mod_src mod_dst sha1_src sha1_dst status name
874 do
875 if test -z "$cached" &&
876 test $sha1_dst = 0000000000000000000000000000000000000000
877 then
878 case "$mod_dst" in
879 160000)
880 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
881 ;;
882 100644 | 100755 | 120000)
883 sha1_dst=$(git hash-object $name)
884 ;;
885 000000)
886 ;; # removed
887 *)
888 # unexpected type
6ff875c5 889 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
890 continue ;;
891 esac
892 fi
893 missing_src=
894 missing_dst=
895
896 test $mod_src = 160000 &&
30353a40 897 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
898 missing_src=t
899
900 test $mod_dst = 160000 &&
30353a40 901 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 902 missing_dst=t
bffe71f4 903
091a6eb0
JK
904 display_name=$(relative_path "$name")
905
1cb639e6
PY
906 total_commits=
907 case "$missing_src,$missing_dst" in
908 t,)
091a6eb0 909 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
910 ;;
911 ,t)
091a6eb0 912 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
913 ;;
914 t,t)
091a6eb0 915 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
916 ;;
917 *)
918 errmsg=
919 total_commits=$(
496eeeb1 920 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
921 then
922 range="$sha1_src...$sha1_dst"
923 elif test $mod_src = 160000
924 then
925 range=$sha1_src
926 else
927 range=$sha1_dst
928 fi
929 GIT_DIR="$name/.git" \
b0e621ad 930 git rev-list --first-parent $range -- | wc -l
1cb639e6 931 )
eed35595 932 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
933 ;;
934 esac
935
936 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
937 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
938 if test $status = T
939 then
b3e73449
ÆAB
940 blob="$(gettext "blob")"
941 submodule="$(gettext "submodule")"
1cb639e6
PY
942 if test $mod_dst = 160000
943 then
091a6eb0 944 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 945 else
091a6eb0 946 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
947 fi
948 else
091a6eb0 949 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
950 fi
951 if test -n "$errmsg"
952 then
953 # Don't give error msg for modification whose dst is not submodule
954 # i.e. deleted or changed to blob
955 test $mod_dst = 160000 && echo "$errmsg"
956 else
496eeeb1 957 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 958 then
f2dc06a3
PY
959 limit=
960 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 961 GIT_DIR="$name/.git" \
f2dc06a3 962 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
963 --first-parent $sha1_src...$sha1_dst
964 elif test $mod_dst = 160000
965 then
966 GIT_DIR="$name/.git" \
967 git log --pretty='format: > %s' -1 $sha1_dst
968 else
969 GIT_DIR="$name/.git" \
970 git log --pretty='format: < %s' -1 $sha1_src
971 fi
972 echo
973 fi
974 echo
3ba7407b 975 done
28f9af5d 976}
70c7ac22 977#
941987a5 978# List all submodules, prefixed with:
70c7ac22
LH
979# - submodule not initialized
980# + different revision checked out
981#
982# If --cached was specified the revision in the index will be printed
983# instead of the currently checked out revision.
984#
985# $@ = requested paths (default to all)
986#
23a485e3 987cmd_status()
70c7ac22 988{
5c08dbbd
JH
989 # parse $args after "submodule ... status".
990 while test $# -ne 0
991 do
992 case "$1" in
993 -q|--quiet)
2e6a30ef 994 GIT_QUIET=1
5c08dbbd
JH
995 ;;
996 --cached)
997 cached=1
998 ;;
64b19ffe
JH
999 --recursive)
1000 recursive=1
1001 ;;
5c08dbbd
JH
1002 --)
1003 shift
1004 break
1005 ;;
1006 -*)
1007 usage
1008 ;;
1009 *)
1010 break
1011 ;;
1012 esac
1013 shift
1014 done
1015
74703a1e 1016 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1017 while read mode sha1 stage sm_path
70c7ac22 1018 do
be9d0a3a 1019 die_if_unmatched "$mode"
0ea306ef 1020 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1021 url=$(git config submodule."$name".url)
091a6eb0 1022 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1023 if test "$stage" = U
1024 then
1025 say "U$sha1 $displaypath"
1026 continue
1027 fi
496eeeb1
EP
1028 if test -z "$url" ||
1029 {
1030 ! test -d "$sm_path"/.git &&
1031 ! test -f "$sm_path"/.git
1032 }
70c7ac22 1033 then
64b19ffe 1034 say "-$sha1 $displaypath"
70c7ac22
LH
1035 continue;
1036 fi
64394e3a 1037 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1038 then
b545cd15 1039 set_name_rev "$sm_path" "$sha1"
64b19ffe 1040 say " $sha1 $displaypath$revname"
70c7ac22
LH
1041 else
1042 if test -z "$cached"
1043 then
14111fc4 1044 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1045 fi
b545cd15 1046 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1047 say "+$sha1 $displaypath$revname"
1048 fi
1049
1050 if test -n "$recursive"
1051 then
1052 (
1053 prefix="$displaypath/"
14111fc4 1054 sanitize_submodule_env
10450cf7 1055 wt_prefix=
64394e3a 1056 cd "$sm_path" &&
e15bec0e 1057 eval cmd_status
64b19ffe 1058 ) ||
64394e3a 1059 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1060 fi
1061 done
1062}
2327f61e
DA
1063#
1064# Sync remote urls for submodules
1065# This makes the value for remote.$remote.url match the value
1066# specified in .gitmodules.
1067#
1068cmd_sync()
1069{
1070 while test $# -ne 0
1071 do
1072 case "$1" in
1073 -q|--quiet)
2e6a30ef 1074 GIT_QUIET=1
2327f61e
DA
1075 shift
1076 ;;
82f49f29
PH
1077 --recursive)
1078 recursive=1
1079 shift
1080 ;;
2327f61e
DA
1081 --)
1082 shift
1083 break
1084 ;;
1085 -*)
1086 usage
1087 ;;
1088 *)
1089 break
1090 ;;
1091 esac
1092 done
1093 cd_to_toplevel
74703a1e 1094 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1095 while read mode sha1 stage sm_path
2327f61e 1096 do
be9d0a3a 1097 die_if_unmatched "$mode"
0ea306ef 1098 name=$(git submodule--helper name "$sm_path")
2327f61e 1099 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1100
1101 # Possibly a url relative to parent
1102 case "$url" in
1103 ./*|../*)
967b2c66
JS
1104 # rewrite foo/bar as ../.. to find path from
1105 # submodule work tree to superproject work tree
6a066230 1106 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1107 # guarantee a trailing /
1108 up_path=${up_path%/}/ &&
1109 # path from submodule work tree to submodule origin repo
63e95beb 1110 sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
967b2c66 1111 # path from superproject work tree to submodule origin repo
63e95beb 1112 super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
967b2c66
JS
1113 ;;
1114 *)
1115 sub_origin_url="$url"
1116 super_config_url="$url"
baede9f8
JH
1117 ;;
1118 esac
1119
ccee6086 1120 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1121 then
091a6eb0
JK
1122 displaypath=$(relative_path "$prefix$sm_path")
1123 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1124 git config submodule."$name".url "$super_config_url"
ccee6086 1125
64394e3a 1126 if test -e "$sm_path"/.git
ccee6086
JH
1127 then
1128 (
14111fc4 1129 sanitize_submodule_env
64394e3a 1130 cd "$sm_path"
ccee6086 1131 remote=$(get_default_remote)
967b2c66 1132 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1133
1134 if test -n "$recursive"
1135 then
1136 prefix="$prefix$sm_path/"
1137 eval cmd_sync
1138 fi
ccee6086
JH
1139 )
1140 fi
2327f61e
DA
1141 fi
1142 done
1143}
70c7ac22 1144
5c08dbbd
JH
1145# This loop parses the command line arguments to find the
1146# subcommand name to dispatch. Parsing of the subcommand specific
1147# options are primarily done by the subcommand implementations.
1148# Subcommand specific options such as --branch and --cached are
1149# parsed here as well, for backward compatibility.
1150
1151while test $# != 0 && test -z "$command"
70c7ac22
LH
1152do
1153 case "$1" in
cf419828 1154 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1155 command=$1
70c7ac22
LH
1156 ;;
1157 -q|--quiet)
2e6a30ef 1158 GIT_QUIET=1
70c7ac22 1159 ;;
ecda0723
SV
1160 -b|--branch)
1161 case "$2" in
1162 '')
1163 usage
1164 ;;
1165 esac
1166 branch="$2"; shift
1167 ;;
70c7ac22 1168 --cached)
28f9af5d 1169 cached="$1"
70c7ac22
LH
1170 ;;
1171 --)
1172 break
1173 ;;
1174 -*)
1175 usage
1176 ;;
1177 *)
1178 break
1179 ;;
1180 esac
1181 shift
1182done
1183
5c08dbbd 1184# No command word defaults to "status"
af9c9f97
RR
1185if test -z "$command"
1186then
1187 if test $# = 0
1188 then
1189 command=status
1190 else
1191 usage
1192 fi
1193fi
5c08dbbd
JH
1194
1195# "-b branch" is accepted only by "add"
1196if test -n "$branch" && test "$command" != add
1197then
ecda0723 1198 usage
5c08dbbd
JH
1199fi
1200
28f9af5d 1201# "--cached" is accepted only by "status" and "summary"
496eeeb1 1202if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1203then
70c7ac22 1204 usage
5c08dbbd
JH
1205fi
1206
1207"cmd_$command" "$@"